/** Copyright (c) 2011-2015, SpaceToad and the BuildCraft Team http://www.mod-buildcraft.com
 * <p/>
 * BuildCraft is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL. Please check the contents
 * of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt */
package buildcraft.core.lib.inventory;

import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;

import buildcraft.api.core.IInvSlot;

public class TransactorRoundRobin extends TransactorSimple {

    public TransactorRoundRobin(IInventory inventory) {
        super(inventory);
    }

    @Override
    public int inject(ItemStack stack, EnumFacing orientation, boolean doAdd) {

        int added = 0;

        for (int itemLoop = 0; itemLoop < stack.field_77994_a; ++itemLoop) { // add 1 item n times.

            int smallestStackSize = Integer.MAX_VALUE;
            IInvSlot minSlot = null;

            for (IInvSlot slot : InventoryIterator.getIterable(inventory, orientation)) {
                ItemStack stackInInventory = slot.getStackInSlot();

                if (stackInInventory == null) {
                    continue;
                }

                if (stackInInventory.field_77994_a >= stackInInventory.func_77976_d()) {
                    continue;
                }

                if (stackInInventory.field_77994_a >= inventory.func_70297_j_()) {
                    continue;
                }

                if (StackHelper.canStacksMerge(stack, stackInInventory) && stackInInventory.field_77994_a < smallestStackSize) {
                    smallestStackSize = stackInInventory.field_77994_a;
                    minSlot = slot;
                }
                if (smallestStackSize <= 1) {
                    break;
                }
            }

            if (minSlot != null) {
                added += addToSlot(minSlot, stack, stack.field_77994_a - 1, doAdd); // add 1 item n times, into the selected
                // slot
            } else {
                break;
            }

        }

        return added;
    }
}
