package buildcraft.silicon;

import java.util.List;

import net.minecraft.block.BlockDispenser;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.dispenser.BehaviorDefaultDispenseItem;
import net.minecraft.dispenser.IBlockSource;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;

import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import buildcraft.core.lib.items.ItemBuildCraft;
import buildcraft.core.lib.utils.NBTUtils;
import buildcraft.silicon.render.PackageFontRenderer;

public class ItemPackage extends ItemBuildCraft {
    public static final class DispenseBehaviour extends BehaviorDefaultDispenseItem {
        @Override
        public ItemStack func_82487_b(IBlockSource source, ItemStack stack) {
            if (stack != null && stack.func_77973_b() instanceof ItemPackage) {
                World world = source.func_82618_k();
                EnumFacing enumfacing = BlockDispenser.func_149937_b(source.func_82620_h());

                EntityPackage entityPackage = new EntityPackage(source.func_82618_k(), source.func_82615_a() + enumfacing.func_82601_c(), source.func_82617_b()
                    + enumfacing.func_96559_d(), source.func_82616_c() + enumfacing.func_82599_e(), stack.func_77946_l());
                entityPackage.func_70186_c(enumfacing.func_82601_c(), enumfacing.func_96559_d() + 0.1F, enumfacing.func_82599_e(),
                        1.1F, 6.0F);
                world.func_72838_d(entityPackage);
                stack.func_77979_a(1);
            }
            return stack;
        }
    }

    public ItemPackage() {
        super();
        func_77625_d(1);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_150895_a(Item item, CreativeTabs tab, List<ItemStack> list) {}

    public static void update(ItemStack stack) {}

    public static ItemStack getStack(ItemStack stack, int slot) {
        NBTTagCompound tag = NBTUtils.getItemData(stack);
        if (tag.func_74764_b("item" + slot)) {
            return ItemStack.func_77949_a(tag.func_74775_l("item" + slot));
        } else {
            return null;
        }
    }

    @Override
    public ItemStack func_77659_a(ItemStack stack, World world, EntityPlayer player) {
        world.func_72956_a(player, "random.bow", 0.5F, 0.4F / (field_77697_d.nextFloat() * 0.4F + 0.8F));

        if (!world.field_72995_K) {
            world.func_72838_d(new EntityPackage(world, player, stack.func_77946_l()));
        }

        if (!player.field_71075_bZ.field_75098_d) {
            stack.field_77994_a--;
        }

        return stack;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public FontRenderer getFontRenderer(ItemStack stack) {
        return new PackageFontRenderer(stack);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_77624_a(ItemStack stack, EntityPlayer player, List<String> strings, boolean adv) {
        NBTTagCompound tag = NBTUtils.getItemData(stack);
        if (!tag.func_82582_d()) {
            strings.add("SPECIAL:0");
            strings.add("SPECIAL:1");
            strings.add("SPECIAL:2");
        }
    }
}
