/** Copyright (c) 2011-2015, SpaceToad and the BuildCraft Team http://www.mod-buildcraft.com
 * <p/>
 * BuildCraft is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL. Please check the contents
 * of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt */
package buildcraft.transport.stripes;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.item.EntityMinecartContainer;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;

import buildcraft.api.transport.IStripesActivator;
import buildcraft.api.transport.IStripesHandler;

public class StripesHandlerMinecartDestroy implements IStripesHandler {

    @Override
    public StripesHandlerType getType() {
        return StripesHandlerType.BLOCK_BREAK;
    }

    @Override
    public boolean shouldHandle(ItemStack stack) {
        return true;
    }

    @Override
    public boolean handle(World world, BlockPos pos, EnumFacing direction, ItemStack stack, EntityPlayer player, IStripesActivator activator) {
        AxisAlignedBB box = new AxisAlignedBB(pos, pos.func_177982_a(1, 1, 1));
        List<Entity> entities = world.func_72839_b(null, box);
        if (entities.size() <= 0) {
            return false;
        }

        List<EntityMinecart> minecarts = new LinkedList<EntityMinecart>();
        for (Object entityObj : entities) {
            if (entityObj instanceof EntityMinecart) {
                minecarts.add((EntityMinecart) entityObj);
            }
        }

        if (minecarts.size() > 0) {
            Collections.shuffle(minecarts);
            EntityMinecart cart = minecarts.get(0);
            if (cart instanceof EntityMinecartContainer) {
                // good job, Mojang. :<
                EntityMinecartContainer container = (EntityMinecartContainer) cart;
                for (int i = 0; i < container.func_70302_i_(); i++) {
                    ItemStack s = container.func_70301_a(i);
                    if (s != null) {
                        container.func_70299_a(i, null);
                        // Safety check
                        if (container.func_70301_a(i) == null) {
                            activator.sendItem(s, direction.func_176734_d());
                        }
                    }
                }
            }
            /* cart.captureDrops = true; cart.killMinecart(DamageSource.generic); for (EntityItem s :
             * cart.capturedDrops) { activator.sendItem(s.getEntityItem(), direction.getOpposite()); } */
            cart.func_70106_y();
            activator.sendItem(cart.getCartItem(), direction.func_176734_d());
            return true;
        }

        return false;
    }
}
